/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.github.pagehelper.PageInfo
 *  com.ruoyi.common.core.utils.StringUtils
 *  com.ruoyi.common.core.utils.bean.BeanUtils
 *  com.ruoyi.common.core.utils.poi.ExcelUtil
 *  com.ruoyi.common.core.web.controller.BaseController
 *  com.ruoyi.common.core.web.domain.AjaxResult
 *  com.ruoyi.common.core.web.page.TableDataInfo
 *  com.ruoyi.common.log.annotation.Log
 *  com.ruoyi.common.log.enums.BusinessType
 *  com.ruoyi.common.security.annotation.RequiresPermissions
 *  com.ruoyi.system.controller.SnServerTemplateController
 *  com.ruoyi.system.domain.SnServerTemplate
 *  com.ruoyi.system.domain.dto.DeploySSLParams
 *  com.ruoyi.system.domain.dto.SnServerTemplateListDto
 *  com.ruoyi.system.domain.dto.UpdateBaseParams
 *  com.ruoyi.system.service.ISnServerTemplateService
 *  com.ruoyi.system.service.ISnTemplateService
 *  javax.servlet.http.HttpServletResponse
 *  org.springframework.beans.factory.annotation.Autowired
 *  org.springframework.web.bind.annotation.DeleteMapping
 *  org.springframework.web.bind.annotation.GetMapping
 *  org.springframework.web.bind.annotation.PathVariable
 *  org.springframework.web.bind.annotation.PostMapping
 *  org.springframework.web.bind.annotation.PutMapping
 *  org.springframework.web.bind.annotation.RequestBody
 *  org.springframework.web.bind.annotation.RequestMapping
 *  org.springframework.web.bind.annotation.RestController
 */
package com.ruoyi.system.controller;

import com.github.pagehelper.PageInfo;
import com.ruoyi.common.core.utils.StringUtils;
import com.ruoyi.common.core.utils.bean.BeanUtils;
import com.ruoyi.common.core.utils.poi.ExcelUtil;
import com.ruoyi.common.core.web.controller.BaseController;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.ruoyi.common.core.web.page.TableDataInfo;
import com.ruoyi.common.log.annotation.Log;
import com.ruoyi.common.log.enums.BusinessType;
import com.ruoyi.common.security.annotation.RequiresPermissions;
import com.ruoyi.system.domain.SnServerTemplate;
import com.ruoyi.system.domain.dto.DeploySSLParams;
import com.ruoyi.system.domain.dto.SnServerTemplateListDto;
import com.ruoyi.system.domain.dto.UpdateBaseParams;
import com.ruoyi.system.service.ISnServerTemplateService;
import com.ruoyi.system.service.ISnTemplateService;
import java.util.List;
import javax.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping(value={"/SnServerTemplate"})
public class SnServerTemplateController
extends BaseController {
    @Autowired
    private ISnServerTemplateService snServerTemplateService;
    @Autowired
    private ISnTemplateService snTemplateService;

    @PostMapping(value={"/getOwnLast"})
    public AjaxResult getOwnLast(@RequestBody SnServerTemplate params) {
        if (params.getServerId() == null) {
            return AjaxResult.error((String)"参数不能为空");
        }
        return this.snServerTemplateService.getOwnLast(params.getServerId());
    }

    @RequiresPermissions(value={"system:SnServerTemplate:list"})
    @GetMapping(value={"/list"})
    public TableDataInfo list(SnServerTemplate snServerTemplate) {
        this.startPage();
        List list = this.snServerTemplateService.selectSnServerTemplateList(snServerTemplate);
        TableDataInfo rspData = new TableDataInfo();
        rspData.setCode(200);
        rspData.setRows(BeanUtils.copyList((List)list, SnServerTemplateListDto.class));
        rspData.setMsg("查询成功");
        rspData.setTotal(new PageInfo(list).getTotal());
        return rspData;
    }

    @RequiresPermissions(value={"system:SnServerTemplate:export"})
    @Log(title="导出客户端", businessType=BusinessType.EXPORT)
    @PostMapping(value={"/export"})
    public void export(HttpServletResponse response, SnServerTemplate snServerTemplate) {
        List list = this.snServerTemplateService.selectSnServerTemplateList(snServerTemplate);
        ExcelUtil util = new ExcelUtil(SnServerTemplate.class);
        util.exportExcel(response, list, "服务器使用模板数据");
    }

    @RequiresPermissions(value={"system:SnServerTemplate:query"})
    @GetMapping(value={"/{id}"})
    public AjaxResult getInfo(@PathVariable(value="id") Long id) {
        return this.success((Object)this.snServerTemplateService.selectSnServerTemplateById(id));
    }

    @RequiresPermissions(value={"system:SnServerTemplate:add"})
    @Log(title="新增客户端", businessType=BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody SnServerTemplate snServerTemplate) {
        if (snServerTemplate.getTemplateId() == null) {
            return this.error("请先选择模板");
        }
        if (snServerTemplate.getServerId() == null) {
            return this.error("请先选择服务器");
        }
        if (StringUtils.isEmpty((String)snServerTemplate.getDomain())) {
            return this.error("请填写部署域名");
        }
        if (snServerTemplate.getDomain().startsWith("http")) {
            return this.error("域名不能包含http://或https://前缀");
        }
        if (snServerTemplate.getDomain().contains("/")) {
            return this.error("域名不能包含/");
        }
        return this.snServerTemplateService.insertSnServerTemplate(snServerTemplate);
    }

    @RequiresPermissions(value={"system:SnServerTemplate:edit"})
    @Log(title="修改客户端", businessType=BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody SnServerTemplate snServerTemplate) {
        return this.toAjax(this.snServerTemplateService.updateSnServerTemplate(snServerTemplate));
    }

    @RequiresPermissions(value={"system:SnServerTemplate:remove"})
    @Log(title="删除客户端", businessType=BusinessType.DELETE)
    @DeleteMapping(value={"/{ids}"})
    public AjaxResult remove(@PathVariable Long[] ids) {
        return this.toAjax(this.snServerTemplateService.deleteSnServerTemplateByIds(ids));
    }

    @RequiresPermissions(value={"system:SnServerTemplate:changeDomain"})
    @Log(title="更换客户端域名", businessType=BusinessType.OTHER)
    @PostMapping(value={"/changeDomain"})
    public AjaxResult changeDomain(@RequestBody SnServerTemplate snServerTemplate) {
        if (StringUtils.isEmpty((String)snServerTemplate.getDomain())) {
            return this.error("请先填写域名");
        }
        if (snServerTemplate.getId() == null) {
            return this.error("服务器模板不能为空");
        }
        return this.snServerTemplateService.changeDomain(snServerTemplate);
    }

    @RequiresPermissions(value={"system:SnServerTemplate:deployDomainSSL"})
    @Log(title="部署客户端域名ssl证书", businessType=BusinessType.OTHER)
    @PostMapping(value={"/deployDomainSSL"})
    public AjaxResult deployDomainSSL(@RequestBody DeploySSLParams params) {
        if (params.getId() == null) {
            return this.error("客户端ID不能为空");
        }
        if (params.getType() == null) {
            return this.error("证书类型不能为空");
        }
        if (params.getType() != 1 && params.getType() != 2) {
            return this.error("证书类型有误");
        }
        if (params.getType() == 2 && StringUtils.isEmpty((String)params.getSslKey())) {
            return this.error("请先填写域名");
        }
        if (params.getType() == 2 && StringUtils.isEmpty((String)params.getSslPem())) {
            return this.error("请先填写域名");
        }
        return this.snServerTemplateService.deployDomainSSL(params);
    }

    @RequiresPermissions(value={"system:SnServerTemplate:updateUI"})
    @Log(title="更新客户端UI包", businessType=BusinessType.OTHER)
    @PostMapping(value={"/updateUI"})
    public AjaxResult updateUI(@RequestBody UpdateBaseParams params) {
        if (params.getId() == null) {
            return this.error("客户端ID不能为空");
        }
        return this.snServerTemplateService.updateUI(params);
    }

    @RequiresPermissions(value={"system:SnServerTemplate:updateUI"})
    @PostMapping(value={"/haveUpdate"})
    public AjaxResult haveUpdate(@RequestBody UpdateBaseParams params) {
        if (params.getId() == null) {
            return this.error("服务器ID不能为空");
        }
        return this.snServerTemplateService.haveUpdate(params);
    }

    @RequiresPermissions(value={"system:SnServerTemplate:updateUI"})
    @Log(title="更新所有客户端UI包", businessType=BusinessType.OTHER)
    @PostMapping(value={"/updateAllUI"})
    public AjaxResult updateAllUI(@RequestBody UpdateBaseParams params) {
        if (params.getId() == null) {
            return this.error("服务器ID不能为空");
        }
        return this.snServerTemplateService.updateAllUI(params);
    }
}

